/* Director.java
 * @autor  prof. dr Sinisa Vlajic,
 * Univerzitet u Beogradu
 * Fakultet organizacionih nauka 
 * Katedra za softversko inzenjerstvo
 * Laboratorija za softversko inzenjerstvo
 * 06.11.2017
 */

//  ZZPSI1:    ,         : 
// Kreira se nov proizvod!!!
// Proizvod od ConcreteBuilder1:  ProductA-ProductA2  ProductB-ProductB2
// Proizvod je vec kreirana!!! 

//              . 
//          (...)

package ZPSI1;

// :   Instance()      
//    (cb1).
class ConcreteBuilderSingleton
{ static boolean jedinstvenoPojavljivanje=false;
  static ConcreteBuilder1 cb1;
  static ConcreteBuilder1 Instance() 
         {     if (jedinstvenoPojavljivanje==false)
                   { System.out.println("Kreira se nov proizvod!!!");
                      ...
                      cb1 = new ConcreteBuilder1();
  	      }
	   else
	      { System.out.println("Proizvod je vec kreirana!!!"); }
  	   return cb1;
        }
}



// :    Builder        .
abstract class Builder 
{ AbstractProductA apa;
  AbstractProductB apb;
  Product prod;
  Builder(){prod = new Product();}
  ...
  abstract void createProductB();
  void createProduct() { prod.p  = " ProductA-" + apa.getProductA() + "  ProductB-" + apb.getProductB();}
  String getProduct() {return prod.p;}
}


/*:     . */
interface AbstractProductA  
{String getProductA();}

interface AbstractProductB 
{String getProductB();}

// :   Builder ,      .
class ConcreteBuilder1 extends Builder 
{ @Override
  public void createProductA(){...}
  @Override
  public void createProductB() {apb = new ProductB2();}
}
  
class ConcreteBuilder2 extends Builder 
{ @Override
  public void createProductA(){apa =  new ProductA2();}
  @Override
  public void createProductB() {apb = new ProductB1();}
}


/* : )    (ProductA1,ProductA2,ProductB1,ProductB2)     
                  (ConcreteBuilder1  ConcreteBuilder2).
           )     AbstractProductA  AbstractProductB. */
class ProductA1 implements AbstractProductA  
{@Override
 public String getProductA(){return "ProductA1";}}

class ProductA2 implements AbstractProductA   
{@Override
 public String getProductA(){return "ProductA2";}}

class ProductB1 implements AbstractProductB 
{@Override
 public String getProductB(){return "ProductB1";}}

class ProductB2 implements AbstractProductB 
{@Override
 public String getProductB(){return "ProductB2";}}

// :    Builder     .
class Director  // 
{
  Builder bui; 
  
  Director(Builder bui1){bui = bui1;}
  public static void main(String args[])
	{  Director di;
           ConcreteBuilder1 cbu1 = ConcreteBuilderSingleton.Instance();  
           di = new Director(...);
           di.Construct();
           System.out.println("Proizvod od ConcreteBuilder1: " + di.bui.getProduct());

           ConcreteBuilder1 cbu11 = ConcreteBuilderSingleton.Instance();  //       .
        }

 void Construct() 
   {   bui.createProductA();
       bui.createProductB();
       bui.createProduct();
   }
}

// :        Director   Construct()l 
class Product {String p;}


